import { LayoutConfigOptions, BreakPoint } from 'ngx-flexible-layout/core';
export * from 'ngx-flexible-layout/core';
import * as i2 from 'ngx-flexible-layout/extended';
export * from 'ngx-flexible-layout/extended';
import * as i1 from 'ngx-flexible-layout/flex';
export * from 'ngx-flexible-layout/flex';
import * as i3 from 'ngx-flexible-layout/grid';
export * from 'ngx-flexible-layout/grid';
import * as i0 from '@angular/core';
import { ModuleWithProviders, Version } from '@angular/core';

/**
 * FlexLayoutModule -- the main import for all utilities in the Angular Layout library
 * * Will automatically provide Flex, Grid, and Extended modules for use in the application
 * * Can be configured using the static withConfig method, options viewable on the Wiki's
 *   Configuration page
 */
declare class FlexLayoutModule {
    /**
     * Initialize the FlexLayoutModule with a set of config options,
     * which sets the corresponding tokens accordingly
     */
    static withConfig(configOptions: LayoutConfigOptions, breakpoints?: BreakPoint | BreakPoint[]): ModuleWithProviders<FlexLayoutModule>;
    constructor(serverModuleLoaded: boolean, platformId: Object);
    static ɵfac: i0.ɵɵFactoryDeclaration<FlexLayoutModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<FlexLayoutModule, never, [typeof i1.FlexModule, typeof i2.ExtendedModule, typeof i3.GridModule], [typeof i1.FlexModule, typeof i2.ExtendedModule, typeof i3.GridModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<FlexLayoutModule>;
}

/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */

/** Current version of Angular Flex-Layout. */
declare const VERSION: Version;

export { FlexLayoutModule, VERSION };
